//import PVector.div;

class Point {
  PVector p = new PVector();
  PVector v = new PVector();
  PVector a = new PVector();
  float m = 1;
  boolean fixed = false;
  
  Point() {
  }
  
  Point(PVector p, float m) {
    this.p.set(p);
    this.m = m;
  }

  void resetForce() {
    a.set(0, 0);
  }
  
  void applyForce(PVector f) {
    // F = m a
    // a = F / m
    a.add(PVector.div(f, m));
  }

  void applyAcceleration(PVector f) {
    // F = m a
    // a = F / m
    a.add(PVector.div(f, m));
  }

  void update(float delta) {
    // mid point v
    PVector pMid = PVector.add(p, PVector.mult(v, delta / 2));

    PVector vMid = PVector.add(v, PVector.mult(a, delta / 2));
    
    
    // update position
//    p.add(PVector.mult(v, delta));
    p.add(PVector.mult(vMid, delta));

    // update velocity
    v.add(PVector.mult(a, delta));
  }
  
  void draw() {
    ellipse(p.x - 2, p.y - 2, 5, 5);
  }
  
}
