// midpoint method

Point[] ps;
Link link;
long lastTime = 0;

void setup() {
  size(640, 360);
  
  // prepare geometry
  ps = new Point[]{new Point(new PVector(100, 50), 1), new Point(new PVector(200, 50), 1)};
  link = new Link();
  link.p0 = 0;
  link.p1 = 1;
  link.k = 30;
  link.l = PVector.sub(ps[link.p0].p, ps[link.p1].p).mag();

  lastTime = millis();
}

void draw() {
  background(0);

  long now = millis();
  float delta = (now - lastTime) / 1000.f;
  lastTime = now;
  
  // half update position
  PVector pMid = PVector.add(ps[0].p, PVector.mult(ps[0].v, delta / 2));
  
  // apply forces
  ps[0].resetForce();
  
  ps[0].applyAcceleration(new PVector(0, 100));
  // spring force
  // F = -(l - l0) * k * dir / |dir|
  //PVector dir = PVector.sub(ps[link.p1].p, ps[link.p0].p);
  PVector dir = PVector.sub(ps[link.p1].p, pMid);
  float l = dir.mag();
  PVector f = PVector.div(PVector.mult(dir, (l - link.l) * link.k), l);
  ps[0].applyForce(f);

  //ps[0].update(delta);
  
  // half update velocity
  PVector vMid = PVector.add(ps[0].v, PVector.mult(ps[0].a, delta / 2));
  
  
  // update position
//    p.add(PVector.mult(v, delta));
  ps[0].p.add(PVector.mult(vMid, delta));

  // update velocity
  ps[0].v.add(PVector.mult(ps[0].a, delta));


  
  ps[0].draw();
  ps[1].draw();
  
  
}
